#include <bits/stdc++.h>
#include <string>

using namespace std;

long long n,m,c,s;

int b[100005];

int a[20000005];

int i,j;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);

    cin>>n>>m;

    for(i=1;i<=m;i++)
        cin>>b[i];

    cin>>c;

    for(j=1;j<=n;j++)
        a[j]=j;

    for(i=0;i<=n-m;i++)
        for(j=1;j<=m;j++)
            a[i+b[j]]=a[i+j];
    s=0;

    for(i=1;i<=n;i++)
        s=s+(int)(pow(c,i)*a[i])%998244353;

    cout<<s;

    return 0;
}